# Tai
👻 在 Windows 上记录软件使用时长

<img src="index.jpg" width=600 />

类似于 iPhone 的屏幕使用时长一样，Tai 负责记录你每一个软件的使用时长。需要注意的是，使用时长并不是软件的存活时间，而是软件从获得焦点时开始到失去焦点后这段时间。

## 开始使用

### 安装环境

使用之前，你的电脑必须安装 [.NET Framework](https://dotnet.microsoft.com/en-us/download/dotnet-framework) `4.6.1` 或更高的版本。

### 下载软件

然后在 [releases](https://github.com/Planshit/Tai/releases) 中下载编译好的 exe 可执行文件压缩包，下载并解压进入目录找到 `Tai.exe` 启动程序，成功启动后可以在状态栏看到 👻 图标。

双击图标可以进入程序主界面，右击图标显示快捷菜单。

只要启动了 Tai ，之后无需做任何操作，它就会在后台开始记录。

## 了解更多

一些你可能想知道的...

### 关联进程

如果你希望在多屏工作时将其他屏幕所使用的软件同时记录时长，那么可以在设置中添加关联。设置完成后，当你正在使用某项关联进程中的任意一个软件时都会去同步更新该项关联其他的进程（软件）使用时长，当然前提是其他进程（软件）也在运行中。

比如在屏幕A打开了VS Code（假设进程名：vscode），屏幕B打开了浏览器（假设进程名：chrome），我希望两个软件的使用时长是同步的，那么就可以在设置中添加一项关联，关联名称随意填写，然后在关联进程中添加两个进程，分别是：vscode、chrome，这样关联就设置好了。需要注意，一个进程只能关联一次，不能重复与其他项关联。

### 热力方块

你可能会在很多地方看到一些方块、卡片带有颜色，在 Tai 我称它为热力方块。使用时长越长颜色则越深，跟 Github 的贡献图类似。

### 使用提示

- `部分软件没有统计数据` 请以“管理员身份”运行Tai，否则部分软件无法统计使用时长。
- `报毒` 请别担心，因Tai的“Observer观察服务”会hook所有进程的event用来实现获取活动进程，“Sleepdiscover睡眠监测服务”会设置全局键盘钩子用来辅助实现唤醒、睡眠监测，所以会导致被安全软件报毒。
- 根据部分用户的反馈来看，在笔记本电脑或平板设备上使用可能会出现UI卡顿、布局错乱的问题，目前暂时没有解决方案，非常抱歉。

#### 👻 是否对你有帮助？

如果有，请作者一杯☕续一下命吧 ╰(￣ω￣ｏ) 谢谢

![](https://raw.githubusercontent.com/Planshit/ProjectEye/master/donate.jpg)
